LeetCode //C - 746. Min Cost Climbing Stairs

746. Min Cost Climbing Stairs

You are given an integer array cost where cost[i] is the cost of i t h i^{th} ith step on a staircase. Once you pay the cost, you can either climb one or two steps.

You can either start from the step with index 0, or the step with index 1.

Return the minimum cost to reach the top of the floor.
 

Example 1:

Input: cost = [10,15,20]
Output: 15
Explanation: You will start at index 1.
- Pay 15 and climb two steps to reach the top.
The total cost is 15.

Example 2:

Input: cost = [1,100,1,1,1,100,1,1,100,1]
Output: 6
Explanation: You will start at index 0.
- Pay 1 and climb two steps to reach index 2.
- Pay 1 and climb two steps to reach index 4.
- Pay 1 and climb two steps to reach index 6.
- Pay 1 and climb one step to reach index 7.
- Pay 1 and climb two steps to reach index 9.
- Pay 1 and climb one step to reach the top.
The total cost is 6.

Constraints:
  • 2 <= cost.length <= 1000
  • 0 <= cost[i] <= 999

From: LeetCode
Link: 746. Min Cost Climbing Stairs


Solution:

Ideas:

This function calculates the minimum cost to reach the top of the staircase by dynamically finding the minimum cost to reach each step. At the end, since you can reach the top from either the last step or the one before it, it returns the minimum of these two values.

Caode:
int min(int a, int b) {
    return a < b ? a : b;
}

int minCostClimbingStairs(int* cost, int costSize) {
    if (costSize == 2) {
        return min(cost[0], cost[1]);
    }
    
    int dp[costSize];
    dp[0] = cost[0];
    dp[1] = cost[1];
    
    for (int i = 2; i < costSize; i++) {
        dp[i] = min(dp[i - 1], dp[i - 2]) + cost[i];
    }
    
    // Since you can either end on the last step or jump over it from the second to last step,
    // take the minimum of the last two dp values.
    return min(dp[costSize - 1], dp[costSize - 2]);
}

你可能感兴趣的:(LeetCode,leetcode,c语言,算法)